#!/usr/bin/env python

from PyQt4 import QtCore, QtGui
import sys
import gc

a = QtGui.QApplication(sys.argv)

class MyClass(QtCore.QObject):
    def __init__(self, parent = None):
        QtCore.QObject.__init__(self, parent)

parentObj = MyClass()
childObj = MyClass(parentObj)

# Re-init. Note that this doesn't yield an error and
# if no parentObj is given it works as expected in both,
# PyQt3 and PyQt4. If a parentObj is given the following
# gc.collect() call with infinite loop forever (sip
# circular reference) while eating 100% CPU...
MyClass.__init__(childObj, parentObj)

print "Start garbage collector. If this is the last line printed and python not returns we are in the infinite gc loop"
gc.collect()
print "If this line is printed there is no bug!"
